/****************************************************************************
 *
 *                                 M U E S L I   v 1.5
 *
 *
 *     Copyright 2016 IMDEA Materials Institute, Getafe, Madrid, Spain
 *     Contact: muesli.materials@imdea.org
 *     Author: Ignacio Romero (ignacio.romero@imdea.org)
 *
 *     This file is part of MUESLI.
 *
 *     MUESLI is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     MUESLI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with MUESLI.  If not, see <http://www.gnu.org/licenses/>.
 *
*****************************************************************************/
#define _USE_MATH_DEFINES
// Undefine identifiers redefined in MUESLI, but reserved by the standard.
// #define __DBL_MIN_EXP__ (-1021)
// #define __UINT_LEAST16_MAX__ 65535
// #define __ATOMIC_ACQUIRE 2
// #define __FLT_MIN__ 1.17549435082228750797e-38F
// #define __UINT_LEAST8_TYPE__ unsigned char
// #define __INTMAX_C(c) c ## L
// #define __CHAR_BIT__ 8
// #define __UINT8_MAX__ 255
// #define __WINT_MAX__ 4294967295U
// #define __ORDER_LITTLE_ENDIAN__ 1234
// #define __SIZE_MAX__ 18446744073709551615UL
// #define __WCHAR_MAX__ 2147483647
// #define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_1 1
// #define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_2 1
// #define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_4 1
// #define __DBL_DENORM_MIN__ double(4.94065645841246544177e-324L)
// #define __GCC_HAVE_SYNC_COMPARE_AND_SWAP_8 1
// #define __GCC_ATOMIC_CHAR_LOCK_FREE 2
// #define __FLT_EVAL_METHOD__ 0
// #define __unix__ 1
// #define __GCC_ATOMIC_CHAR32_T_LOCK_FREE 2
// #define __x86_64 1
// #define __UINT_FAST64_MAX__ 18446744073709551615UL
// #define __SIG_ATOMIC_TYPE__ int
// #define __DBL_MIN_10_EXP__ (-307)
// #define __FINITE_MATH_ONLY__ 0
// #define __GNUC_PATCHLEVEL__ 5
// #define __UINT_FAST8_MAX__ 255
// #define __DEC64_MAX_EXP__ 385
// #define __INT8_C(c) c
// #define __UINT_LEAST64_MAX__ 18446744073709551615UL
// #define __SHRT_MAX__ 32767
// #define __LDBL_MAX__ 1.18973149535723176502e+4932L
// #define __UINT_LEAST8_MAX__ 255
// #define __GCC_ATOMIC_BOOL_LOCK_FREE 2
// #define __UINTMAX_TYPE__ long unsigned int
// #define __linux 1
// #define __DEC32_EPSILON__ 1E-6DF
// #define __unix 1
// #define __UINT32_MAX__ 4294967295U
// #define __LDBL_MAX_EXP__ 16384
// #define __WINT_MIN__ 0U
// #define __linux__ 1
// #define __SCHAR_MAX__ 127
// #define __WCHAR_MIN__ (-__WCHAR_MAX__ - 1)
// #define __INT64_C(c) c ## L
// #define __DBL_DIG__ 15
// #define __GCC_ATOMIC_POINTER_LOCK_FREE 2
// #define __SIZEOF_INT__ 4
// #define __SIZEOF_POINTER__ 8
// #define __GCC_ATOMIC_CHAR16_T_LOCK_FREE 2
// #define __USER_LABEL_PREFIX__
// #define __LDBL_HAS_INFINITY__ 1
// #define __FLT_EPSILON__ 1.19209289550781250000e-7F
// #define __GXX_WEAK__ 1
// #define __LDBL_MIN__ 3.36210314311209350626e-4932L
// #define __DEC32_MAX__ 9.999999E96DF
// #define __INT32_MAX__ 2147483647
// #define __SIZEOF_LONG__ 8
// #define __UINT16_C(c) c
// #define __DECIMAL_DIG__ 21
// #define __gnu_linux__ 1
// #define __LDBL_HAS_QUIET_NAN__ 1
// #define __GNUC__ 4
// #define __GXX_RTTI 1
// #define __MMX__ 1
// #define __FLT_HAS_DENORM__ 1
// #define __SIZEOF_LONG_DOUBLE__ 16
// #define __BIGGEST_ALIGNMENT__ 16
#define __DBL_MAX__ double(1.79769313486231570815e+308L)
/* #define __INT_FAST32_MAX__ 9223372036854775807L
#define __DBL_HAS_INFINITY__ 1
#define __INT64_MAX__ 9223372036854775807L
#define __DEC32_MIN_EXP__ (-94)
#define __INT_FAST16_TYPE__ long int
#define __LDBL_HAS_DENORM__ 1
#define __DEC128_MAX__ 9.999999999999999999999999999999999E6144DL
#define __INT_LEAST32_MAX__ 2147483647
#define __DEC32_MIN__ 1E-95DF
#define __DEPRECATED 1
#define __DBL_MAX_EXP__ 1024
#define __DEC128_EPSILON__ 1E-33DL
#define __SSE2_MATH__ 1
#define __ATOMIC_HLE_RELEASE 131072
#define __PTRDIFF_MAX__ 9223372036854775807L
#define __amd64 1
#define __ATOMIC_HLE_ACQUIRE 65536
#define __GNUG__ 4
#define __LONG_LONG_MAX__ 9223372036854775807LL
#define __SIZEOF_SIZE_T__ 8
#define __SIZEOF_WINT_T__ 4
#define __GCC_HAVE_DWARF2_CFI_ASM 1
#define __GXX_ABI_VERSION 1002
#define __FLT_MIN_EXP__ (-125)
#define __INT_FAST64_TYPE__ long int
#define __DBL_MIN__ double(2.22507385850720138309e-308L)
#define __LP64__ 1
#define __DECIMAL_BID_FORMAT__ 1
#define __DEC128_MIN__ 1E-6143DL
#define __REGISTER_PREFIX__
#define __UINT16_MAX__ 65535
#define __DBL_HAS_DENORM__ 1
#define __UINT8_TYPE__ unsigned char
#define __NO_INLINE__ 1
#define __FLT_MANT_DIG__ 24
#define __VERSION__ "4.8.5"
#define __UINT64_C(c) c ## UL
#define __GCC_ATOMIC_INT_LOCK_FREE 2
#define __FLOAT_WORD_ORDER__ __ORDER_LITTLE_ENDIAN__
#define __INT32_C(c) c
#define __DEC64_EPSILON__ 1E-15DD
#define __ORDER_PDP_ENDIAN__ 3412
#define __DEC128_MIN_EXP__ (-6142)
#define __INT_FAST32_TYPE__ long int
#define __UINT_LEAST16_TYPE__ short unsigned int
#define unix 1
#define __INT16_MAX__ 32767
#define __SIZE_TYPE__ long unsigned int
#define __UINT64_MAX__ 18446744073709551615UL
#define __INT8_TYPE__ signed char
#define __ELF__ 1
#define __FLT_RADIX__ 2
#define __INT_LEAST16_TYPE__ short int
#define __LDBL_EPSILON__ 1.08420217248550443401e-19L
#define __UINTMAX_C(c) c ## UL
#define __k8 1
#define __SIG_ATOMIC_MAX__ 2147483647
#define __GCC_ATOMIC_WCHAR_T_LOCK_FREE 2
#define __SIZEOF_PTRDIFF_T__ 8
#define __x86_64__ 1
#define __DEC32_SUBNORMAL_MIN__ 0.000001E-95DF
#define __INT_FAST16_MAX__ 9223372036854775807L
#define __UINT_FAST32_MAX__ 18446744073709551615UL
#define __UINT_LEAST64_TYPE__ long unsigned int
#define __FLT_HAS_QUIET_NAN__ 1
#define __FLT_MAX_10_EXP__ 38
#define __LONG_MAX__ 9223372036854775807L
#define __DEC128_SUBNORMAL_MIN__ 0.000000000000000000000000000000001E-6143DL
#define __FLT_HAS_INFINITY__ 1
#define __UINT_FAST16_TYPE__ long unsigned int
#define __DEC64_MAX__ 9.999999999999999E384DD
#define __CHAR16_TYPE__ short unsigned int
#define __PRAGMA_REDEFINE_EXTNAME 1
#define __INT_LEAST16_MAX__ 32767
#define __DEC64_MANT_DIG__ 16
#define __UINT_LEAST32_MAX__ 4294967295U
#define __GCC_ATOMIC_LONG_LOCK_FREE 2
#define __INT_LEAST64_TYPE__ long int
#define __INT16_TYPE__ short int
#define __INT_LEAST8_TYPE__ signed char
#define __DEC32_MAX_EXP__ 97
#define __INT_FAST8_MAX__ 127
#define __INTPTR_MAX__ 9223372036854775807L
#define linux 1
#define __SSE2__ 1
#define __EXCEPTIONS 1
#define __LDBL_MANT_DIG__ 64
#define __DBL_HAS_QUIET_NAN__ 1
#define __SIG_ATOMIC_MIN__ (-__SIG_ATOMIC_MAX__ - 1)
#define __code_model_small__ 1
#define __k8__ 1
#define __INTPTR_TYPE__ long int
#define __UINT16_TYPE__ short unsigned int
#define __WCHAR_TYPE__ int
#define __SIZEOF_FLOAT__ 4
#define __UINTPTR_MAX__ 18446744073709551615UL
#define __DEC64_MIN_EXP__ (-382)
#define __INT_FAST64_MAX__ 9223372036854775807L
#define __GCC_ATOMIC_TEST_AND_SET_TRUEVAL 1
#define __FLT_DIG__ 6
#define __UINT_FAST64_TYPE__ long unsigned int
#define __INT_MAX__ 2147483647
#define __amd64__ 1
#define __INT64_TYPE__ long int
#define __FLT_MAX_EXP__ 128
#define __ORDER_BIG_ENDIAN__ 4321
#define __DBL_MANT_DIG__ 53
#define __INT_LEAST64_MAX__ 9223372036854775807L
#define __DEC64_MIN__ 1E-383DD
#define __WINT_TYPE__ unsigned int
#define __UINT_LEAST32_TYPE__ unsigned int
#define __SIZEOF_SHORT__ 2
#define __SSE__ 1
#define __LDBL_MIN_EXP__ (-16381)
#define __INT_LEAST8_MAX__ 127
#define __SIZEOF_INT128__ 16
#define __LDBL_MAX_10_EXP__ 4932
#define __ATOMIC_RELAXED 0
#define __DBL_EPSILON__ double(2.22044604925031308085e-16L)
#define _LP64 1
#define __UINT8_C(c) c
#define __INT_LEAST32_TYPE__ int
#define __SIZEOF_WCHAR_T__ 4
#define __UINT64_TYPE__ long unsigned int
#define __INT_FAST8_TYPE__ signed char
#define __DBL_DECIMAL_DIG__ 17
#define __FXSR__ 1
#define __DEC_EVAL_METHOD__ 2
#define __UINT32_C(c) c ## U
#define __INTMAX_MAX__ 9223372036854775807L
#define __BYTE_ORDER__ __ORDER_LITTLE_ENDIAN__
#define __FLT_DENORM_MIN__ 1.40129846432481707092e-45F
#define __INT8_MAX__ 127
#define __UINT_FAST32_TYPE__ long unsigned int
#define __CHAR32_TYPE__ unsigned int
#define __FLT_MAX__ 3.40282346638528859812e+38F
#define __INT32_TYPE__ int
#define __SIZEOF_DOUBLE__ 8
#define __INTMAX_TYPE__ long int
#define __DEC128_MAX_EXP__ 6145
#define __ATOMIC_CONSUME 1
#define __GNUC_MINOR__ 8
#define __UINTMAX_MAX__ 18446744073709551615UL
#define __DEC32_MANT_DIG__ 7
#define __DBL_MAX_10_EXP__ 308
#define __LDBL_DENORM_MIN__ 3.64519953188247460253e-4951L
#define __INT16_C(c) c
#define __STDC__ 1
#define __PTRDIFF_TYPE__ long int
#define __ATOMIC_SEQ_CST 5
#define __UINT32_TYPE__ unsigned int
#define __UINTPTR_TYPE__ long unsigned int
#define __DEC64_SUBNORMAL_MIN__ 0.000000000000001E-383DD
#define __DEC128_MANT_DIG__ 34
#define __LDBL_MIN_10_EXP__ (-4931)
#define __SSE_MATH__ 1
#define __SIZEOF_LONG_LONG__ 8
#define __GCC_ATOMIC_LLONG_LOCK_FREE 2
#define __LDBL_DIG__ 18
#define __FLT_DECIMAL_DIG__ 9
#define __UINT_FAST16_MAX__ 18446744073709551615UL
#define __GNUC_GNU_INLINE__ 1
#define __FLT_MIN_10_EXP__ (-37)
#define __GCC_ATOMIC_SHORT_LOCK_FREE 2
#define __UINT_FAST8_TYPE__ unsigned char
#define _GNU_SOURCE 1
#define __ATOMIC_ACQ_REL 4
#define __ATOMIC_RELEASE 3 */